// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Describes Protocol and thumbprint of Windows Remote Management listener
    /// </summary>
    public partial class WinRMListener
    {
        /// <summary>
        /// Initializes a new instance of the WinRMListener class.
        /// </summary>
        public WinRMListener() { }

        /// <summary>
        /// Initializes a new instance of the WinRMListener class.
        /// </summary>
        /// <param name="protocol">the Protocol used by WinRM listener.
        /// Currently only Http and Https are supported. Possible values
        /// include: 'Http', 'Https'</param>
        /// <param name="certificateUrl">the Certificate URL in KMS for Https
        /// listeners. Should be null for Http listeners.</param>
        public WinRMListener(ProtocolTypes? protocol = default(ProtocolTypes?), string certificateUrl = default(string))
        {
            Protocol = protocol;
            CertificateUrl = certificateUrl;
        }

        /// <summary>
        /// Gets or sets the Protocol used by WinRM listener. Currently only
        /// Http and Https are supported. Possible values include: 'Http',
        /// 'Https'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "protocol")]
        public ProtocolTypes? Protocol { get; set; }

        /// <summary>
        /// Gets or sets the Certificate URL in KMS for Https listeners.
        /// Should be null for Http listeners.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "certificateUrl")]
        public string CertificateUrl { get; set; }

    }
}
