// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Contains sku in an ExpressRouteCircuit
    /// </summary>
    public partial class ExpressRouteCircuitSku
    {
        /// <summary>
        /// Initializes a new instance of the ExpressRouteCircuitSku class.
        /// </summary>
        public ExpressRouteCircuitSku() { }

        /// <summary>
        /// Initializes a new instance of the ExpressRouteCircuitSku class.
        /// </summary>
        /// <param name="name">Gets or sets name of the sku.</param>
        /// <param name="tier">Gets or sets tier of the sku. Possible values
        /// include: 'Standard', 'Premium'</param>
        /// <param name="family">Gets or sets family of the sku. Possible
        /// values include: 'UnlimitedData', 'MeteredData'</param>
        public ExpressRouteCircuitSku(string name = default(string), string tier = default(string), string family = default(string))
        {
            Name = name;
            Tier = tier;
            Family = family;
        }

        /// <summary>
        /// Gets or sets name of the sku.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets tier of the sku. Possible values include: 'Standard',
        /// 'Premium'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "tier")]
        public string Tier { get; set; }

        /// <summary>
        /// Gets or sets family of the sku. Possible values include:
        /// 'UnlimitedData', 'MeteredData'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "family")]
        public string Family { get; set; }

    }
}
