// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// NetworkSecurityGroup resource
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class NetworkSecurityGroupInner : Microsoft.Azure.Management.Resource.Fluent.Resource
    {
        /// <summary>
        /// Initializes a new instance of the NetworkSecurityGroupInner class.
        /// </summary>
        public NetworkSecurityGroupInner() { }

        /// <summary>
        /// Initializes a new instance of the NetworkSecurityGroupInner class.
        /// </summary>
        /// <param name="securityRules">Gets or sets security rules of network
        /// security group</param>
        /// <param name="defaultSecurityRules">Gets or default security rules
        /// of network security group</param>
        /// <param name="networkInterfaces">Gets collection of references to
        /// Network Interfaces</param>
        /// <param name="subnets">Gets collection of references to
        /// subnets</param>
        /// <param name="resourceGuid">Gets or sets resource guid property of
        /// the network security group resource</param>
        /// <param name="provisioningState">Gets provisioning state of the
        /// PublicIP resource Updating/Deleting/Failed</param>
        /// <param name="etag">Gets a unique read-only string that changes
        /// whenever the resource is updated</param>
        public NetworkSecurityGroupInner(string location = default(string), string id = default(string), string name = default(string), string type = default(string), System.Collections.Generic.IDictionary<string, string> tags = default(System.Collections.Generic.IDictionary<string, string>), System.Collections.Generic.IList<SecurityRuleInner> securityRules = default(System.Collections.Generic.IList<SecurityRuleInner>), System.Collections.Generic.IList<SecurityRuleInner> defaultSecurityRules = default(System.Collections.Generic.IList<SecurityRuleInner>), System.Collections.Generic.IList<NetworkInterfaceInner> networkInterfaces = default(System.Collections.Generic.IList<NetworkInterfaceInner>), System.Collections.Generic.IList<SubnetInner> subnets = default(System.Collections.Generic.IList<SubnetInner>), string resourceGuid = default(string), string provisioningState = default(string), string etag = default(string))
            : base(location, id, name, type, tags)
        {
            SecurityRules = securityRules;
            DefaultSecurityRules = defaultSecurityRules;
            NetworkInterfaces = networkInterfaces;
            Subnets = subnets;
            ResourceGuid = resourceGuid;
            ProvisioningState = provisioningState;
            Etag = etag;
        }

        /// <summary>
        /// Gets or sets security rules of network security group
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.securityRules")]
        public System.Collections.Generic.IList<SecurityRuleInner> SecurityRules { get; set; }

        /// <summary>
        /// Gets or default security rules of network security group
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.defaultSecurityRules")]
        public System.Collections.Generic.IList<SecurityRuleInner> DefaultSecurityRules { get; set; }

        /// <summary>
        /// Gets collection of references to Network Interfaces
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.networkInterfaces")]
        public System.Collections.Generic.IList<NetworkInterfaceInner> NetworkInterfaces { get; private set; }

        /// <summary>
        /// Gets collection of references to subnets
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.subnets")]
        public System.Collections.Generic.IList<SubnetInner> Subnets { get; private set; }

        /// <summary>
        /// Gets or sets resource guid property of the network security group
        /// resource
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.resourceGuid")]
        public string ResourceGuid { get; set; }

        /// <summary>
        /// Gets provisioning state of the PublicIP resource
        /// Updating/Deleting/Failed
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; set; }

        /// <summary>
        /// Gets a unique read-only string that changes whenever the resource
        /// is updated
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "etag")]
        public string Etag { get; set; }

    }
}
